<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <link rel="stylesheet" href="./css/pure.css">
    <link rel="stylesheet" href="./css/fontawesome/css/all.css">
    <link rel="stylesheet" href="./css/styles.css">

    <script src="js/nanocurrency-web-js/index.min.js" type="text/javascript"></script>
    <script src="js/qr-creator/qr-creator.min.js" type="text/javascript"></script>
    <script src="js/nostr-tools/nostr.bundle.js" type="text/javascript"></script>
    <script src="js/index.js" type="text/javascript"></script>
    <script src="js/nostr.js" type="text/javascript"></script>
    <script src="js/nano.js" type="text/javascript"></script>
    <script src="js/invidious.js" type="text/javascript"></script>

    <script type="text/javascript">
    async function load() {
      loadIdentity();
      listenForMessages();
      loadNostrRelays();
      loadNostrRelaysList();
      loadNanoNodesList();
      loadDefaultInvidiousInstances();
      loadInvidiousInstancesList();
      loadTabs();

      nanoWallet = (await createWallet()).wallet;
      await addAccountToWallet(nanoWallet, nanoPvtKey);

      await receiveNano(nanoAccount);

      setInterval(loadBalance, 2000);

      renderQRCode('nano:' + nanoAccount + '?label=Nano Chat&message=Send Nano to your Nano Chat wallet');

    }

    async function loadBalance() {

      // await receiveNano(nanoAccount);

      document.getElementById('balance').innerText = parseFloat(
        NanocurrencyWeb.tools.convert
          (
            (await getBalance(nanoAccount)).balance, 'RAW', 'NANO'
          )
      );
    }

    async function onPasteStreamCode(streamCode) {
      try {
        await readStreamCode(streamCode);
        loadPaidMsgs();

        var nanoBalance = parseFloat(NanocurrencyWeb.tools.convert((await getBalance(nanoAccount)).balance, 'RAW', 'NANO'));
        if (nanoBalance == 0) {
          toggleModal("scanQrCode");
        }

      }
      catch(err) {
      }

      if (nanoAddressStreamer !== undefined && 
        nostrChannelEvent !== undefined) {
        document.getElementById('divStreamCode').style.display = "none";
        document.getElementById('divMsg').style.display = "flex";
      }
    }

    function toggleMenu() {
      var sidemenu = document.getElementById('sidemenu').style.display;
      document.getElementById('sidemenu').style.display = sidemenu == "flex" ? "none" : "flex";
      console.log(sidemenu);
    }

    async function sendMessage(msg) {
      var signature = sign(msg);

      if (msg.length == 0) {
        return;
      }

      // readStreamCode(document.getElementById('scode').value);
      var sendBlock = await sendNano(nanoAccount, nanoAddressStreamer, document.getElementById("amount").value, signature + Date.now() / 1000);

      /* while (sendBlock === undefined) {
        sendBlock = await sendNano(nanoAccount, nanoAddressStreamer, document.getElementById("amount").value, signature + Date.now() / 1000);
      } */

      console.log(sendBlock);

      msg = signature + "." + Math.floor(Date.now() / 1000) + '.' + sendBlock.block + '.' + msg;
      var json = JSON.stringify({ author: "Darwin", content: msg });
      sendNostrMessage(json, nostrChannelEvent.data);

      // document.getElementById("signedMsg").innerText = msg;

      return msg;
    }

    function toggleModal(id) {

      if (id != null && id != undefined && id != "") {
        var display = document.querySelector("#" + id).style.display;
      }
      else {
        var display = document.querySelector("#modal-background").style.display;
      }

      if (display != "block") {
        document.querySelector("#" + id).style.display = "block";
        document.querySelector("#modal-background").style.display = "block";
      }
      else {
        document.querySelector("#modal-background").style.display = "none";
        document.querySelectorAll(".modal").forEach((modal) => {
          modal.style.display = "none";
        });
      }

    }

    </script> 

  </head>
  <body onload="load()">
    <header>
      <div>
        <h2>NanoChat</h2>
      </div>
      <nav class="menu">
        <strong id="balance"></strong>
        <a href="#" class="fa-regular fa-user"></a>
        <div class="fa-solid fa-gear" onclick="toggleModal('settings')"></div>
      </nav>
    </header>
    <div class="page">
      <main>
        <div id="divStreamCode" class="pure-form">
          <label for="streamCode">Stream Code:</label>
          <input type="text" id="streamCode" class="pure-input-rounded" oninput="onPasteStreamCode(this.value)"/>
        </div>
        <div id="scanQrCode" class="modal qrCode">
          <div>
            <p>
              Escaneie o QR Code para carregar sua carteira no NanoChat.
            </p>
            <div id="qrCodeImg"></div>
            <p><a onclick="toggleModal('scanQrCode')">Agora não</a></p>
          </div>
        </div>
        <div id="divMsg" class="pure-form" style="display: none;">
          <div id="divMsgs" class="pure-form div-msgs round">
            <div id="lstMsgs"></div>
          </div>
          <label for="amount">Quantia:</label>
          <input type="number" step="0.0001" id="amount" class="pure-input" value="1" />
          <label for="msg">Mensagem:</label>
          <textarea id="msg" rows="3" class="pure-input-1-2"></textarea>
          <button type="button" class="pure-button pure-button-primary round" onclick='sendMessage(document.getElementById("msg").value)'>Enviar</button>
        </div>
      </main>
    </div>   
    <div id="modal-background" onclick="toggleModal()"></div>
    <div id="settings" class="modal settings">
      <div>
        <div id="config">
          <div class="modal-header">
            <h3>Configurações</h3>
            <div onclick="toggleModal('settings')">
              <img src="data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAMAAAAoLQ9TAAAAdVBMVEUAAABNTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU1NTU0N3NIOAAAAJnRSTlMAAQIDBAUGBwgRFRYZGiEjQ3l7hYaqtLm8vsDFx87a4uvv8fP1+bbY9ZEAAAB8SURBVBhXXY5LFoJAAMOCIP4VBRXEv5j7H9HFDOizu2TRFljedgCQHeocWHVaAWStXnKyl2oVWI+kd1XLvFV1D7Ng3qrWKYMZ+MdEhk3gbhw59KvlH0eTnf2mgiRwvQ7NW6aqNmncukKhnvo/zzlQ2PR/HgsAJkncH6XwAcr0FUY5BVeFAAAAAElFTkSuQmCC" width="16" height="16" alt="">
            </div>
          </div>
          <div class="modal-content">
            <div class="pure-form">
              <div class="tabs">
                <button class="tab active">Nostr</button>
                <button class="tab">Nano</button>
                <button class="tab">Invidious</button>
                <button class="tab">Perfil</button>
              </div>
              <div class="contents">
                <div class="content active">
                  <fieldset>
                    <legend><h4>Relays de Nostr</h4></legend>
                    <div>
                      <label for="addNostrRelay">Adicionar Relay:</label>
                      <input type="url" id="addNostrRelay" class="pure-input-rounded"/>
                      <button type="button" class="pure-button pure-button-primary round" onclick="addNostrRelay()">Adicionar</button>
                    </div>
                  </fieldset>
                  <div id="nostrRelays" class="nostrRelays">
                  </div>
                </div>
                <div class="content">
                  <fieldset>
                    <legend><h4>Nodes de Nano</h4></legend>
                    <div>
                      <label for="addNanoNode">Adicionar Node:</label>
                      <input type="url" id="addNanoNode" class="pure-input-rounded"/>
                      <button type="button" class="pure-button pure-button-primary round" onclick="addNanoNode()">Adicionar</button>
                    </div>
                  </fieldset>
                  <div id="nanoNodes" class="nanoNodes">
                  </div>
                </div>
                <div class="content">
                  <fieldset>
                    <legend><h4>Instâncias de Invidious</h4></legend>
                    <div>
                      <label for="addInvidiousInstance">Adicionar Instância:</label>
                      <input type="url" id="addInvidiousInstance" class="pure-input-rounded"/>
                      <button type="button" class="pure-button pure-button-primary round" onclick="addInvidiousInstance()">Adicionar</button>
                    </div>
                  </fieldset>
                  <div id="invidiousInstances" class="invidiousInstances">
                  </div>
                </div>
                <div class="content">
                  <fieldset>
                    <legend><h4>Dados Básicos</h4></legend>
                    <div>
                      <label for="nickname">Nickname:</label>
                      <input type="url" id="nickname" class="pure-input-rounded"/>
                    </div>
                  </fieldset>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <footer>
      <p>NanoChat é uma plataforma gratuita de chat remunerado para lives.</p>
    </footer>
  </body>
</html>
